
local E_MODEL_NESS = smlua_model_util_get_id("ness_geo")

local TEXT_MOD_NAME = "Ness"

local VOICETABLE_NESS = {
	[CHAR_SOUND_OKEY_DOKEY] = 'snd_vc_Ness_Appeal01.ogg', -- Starting game
    [CHAR_SOUND_LETS_A_GO] = 'snd_vc_Ness_Appeal01.ogg', -- Starting level
    [CHAR_SOUND_PUNCH_YAH] = 'snd_vc_Ness_Appeal02.ogg', -- Punch 1
    [CHAR_SOUND_PUNCH_WAH] = 'snd_vc_Ness_Attack01.ogg', -- Punch 2
    [CHAR_SOUND_PUNCH_HOO] = 'snd_vc_Ness_Attack05.ogg', -- Punch 3
    [CHAR_SOUND_YAH_WAH_HOO] = {'snd_vc_Ness_Passive.ogg','snd_vc_Ness_Appeal02.ogg','snd_vc_Ness_Jump01.ogg',}, -- First/Second jump sounds
    [CHAR_SOUND_HOOHOO] = 'snd_vc_Ness_Attack03.ogg', -- Third jump sound
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'snd_vc_Ness_Attack02.ogg','snd_vc_Ness_Attack04.ogg',}, -- Triple jump sounds
    [CHAR_SOUND_UH] = 'snd_vc_Ness_MissFoot01.ogg', -- Wall bonk
    [CHAR_SOUND_UH2] = 'snd_vc_Ness_HeavyGet.ogg', -- Landing after long jump
    [CHAR_SOUND_UH2_2] = 'snd_vc_Ness_Ottotto.ogg', -- Same sound as UH2; jumping onto ledge
    [CHAR_SOUND_HAHA] = 'snd_vc_Ness_Appeal03.ogg', -- Landing triple jump
    [CHAR_SOUND_HAHA_2] = 'snd_vc_Ness_Appeal03.ogg',
    [CHAR_SOUND_YAHOO] = 'snd_vc_Ness_Attack06.ogg', -- Long jump
    [CHAR_SOUND_DOH] = 'snd_vc_Ness_MissFoot02.ogg', -- Long jump wall bonk
    [CHAR_SOUND_WHOA] = 'snd_vc_Ness_CliffCatch.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'snd_vc_Ness_HeavyGet.ogg', -- Climbing over ledge
    [CHAR_SOUND_WAAAOOOW] = 'snd_vc_Ness_Damage_hoshikie.ogg', -- Falling a long distance
    [CHAR_SOUND_TWIRL_BOUNCE] = 'snd_vc_Ness_Appeal03.ogg', -- Bouncing off of a flower spring
    [CHAR_SOUND_GROUND_POUND_WAH] = 'snd_vc_Ness_Attack06.ogg',
    [CHAR_SOUND_HRMM] = 'snd_vc_Ness_HeavyGet.ogg', -- Lifting something
    [CHAR_SOUND_HERE_WE_GO] = 'snd_vc_Ness_Appeal01.ogg', -- Star get
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'snd_vc_Ness_Attack05.ogg', -- Throwing Bowser
    [CHAR_SOUND_OOOF] = 'snd_vc_Ness_Damage01.ogg',
    [CHAR_SOUND_OOOF2] = 'snd_vc_Ness_DamageFly01.ogg',
    [CHAR_SOUND_WAH2] = 'snd_vc_Ness_Attack07.ogg',
--DAMAGE
    [CHAR_SOUND_ATTACKED] = 'snd_vc_Ness_Damage01.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
    [CHAR_SOUND_ON_FIRE] = 'snd_vc_Ness_Damage02.ogg',
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Silent.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Silent.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Cough.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
    [CHAR_SOUND_DYING] = 'snd_vc_Ness_FuraFura.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Silent.ogg', -- Running out of air underwater
    [CHAR_SOUND_MAMA_MIA] = 'snd_vc_Ness_FuraFura.ogg' -- Booted out of level
}

-- All Located in "actors"
local CAPTABLE_NESS = {
    normal = smlua_model_util_get_id("nesscap_geo"),
    wing = smlua_model_util_get_id("nesswing_geo"),
    metal = smlua_model_util_get_id("nessmetal_geo"),
}

local healthHUDTex = {
	label = {
		left = get_texture_info("ness-healthhudback-left"),
		right = get_texture_info("ness-healthhudback-right"),
	},	pie = {
		[1] = get_texture_info("ness-HP1"),
		[2] = get_texture_info("ness-HP2"),
		[3] = get_texture_info("ness-HP3"),
		[4] = get_texture_info("ness-HP4"),
		[5] = get_texture_info("ness-HP5"),
		[6] = get_texture_info("ness-HP6"),
		[7] = get_texture_info("ness-HP7"),
		[8] = get_texture_info("ness-HP8")
	}
}
local TEX_NESS = get_texture_info("ness-icon")

if _G.charSelectExists then
    local ness = _G.charSelect.character_add("Ness", {"Ness is a young boy who's mastered the psychic","power known as PSI. Ness was living a normal life in","the suburbs of Onett until a meteor crashed into a nearby","mountain and sent him on a wild adventure. Believing in","the ultimate powers of wisdom, courage, and friendship,","Ness proves that some heroes come in small packages."}, "SuperPhanto", {r = 99, g = 62, b = 33}, E_MODEL_NESS, CT_MARIO, TEX_NESS)
	
    _G.charSelect.character_add_voice(E_MODEL_NESS, VOICETABLE_NESS)
	_G.charSelect.character_add_caps(E_MODEL_NESS, CAPTABLE_NESS)
	_G.charSelect.character_add_health_meter(ness, healthHUDTex);

    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_NESS then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_NESS then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end


